
%% [MATLAB GUI] Initial code 
function varargout = prog16(varargin)
% PROG16 MATLAB code for prog16.fig
%      PROG16, by itself, creates a new PROG16 or raises the existing
%      singleton*.
%
%      H = PROG16 returns the handle to a new PROG16 or the handle to
%      the existing singleton*.
%
%      PROG16('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PROG16.M with the given input arguments.
%
%      PROG16('Property','Value',...) creates a new PROG16 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before prog16_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to prog16_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Move the above text to modify the response to help prog16

% Last Modified by GUIDE v2.5 26-Feb-2021 17:38:19

% Begin initialization code - DO NOT MOVE

% version 1.1  "Export pdf" added 21/2/25

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @prog16_OpeningFcn, ...
                   'gui_OutputFcn',  @prog16_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT MOVE


% --- Executes just before prog16 is made visible.
function prog16_OpeningFcn(hObject, eventdata, handles, varargin)

% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to prog16 (see VARARGIN)

% Initialize Axes

axes(handles.axes1),
   xlimit = get(gca,'xlim');
   ylimit = get(gca,'ylim');
   text((xlimit(2)+xlimit(1))./2,(ylimit(2)+ylimit(1))./2,...
       {'\fontsize{14}Zijderveld Plot'},...
       'HorizontalAlignment','center','BackgroundColor','w');
   set(gca,'XMinorTick','on');
   set(gca,'YMinorTick','on');
   set(gca,'XTickLabel','');  
   set(gca,'YTickLabel',''); 
   set(gca,'Ticklength',[0.015;0.04]);
   box on;
   
axes(handles.axes2),
   xlimit = get(gca,'xlim');
   ylimit = get(gca,'ylim');
   text((xlimit(2)+xlimit(1))./2,(ylimit(2)+ylimit(1))./2,...
       {'\fontsize{14}Int vs Demag Plot'},...
       'HorizontalAlignment','center','BackgroundColor','w');
   set(gca,'XMinorTick','on');
   set(gca,'YMinorTick','on');
   set(gca,'XTickLabel','');  
   set(gca,'YTickLabel',''); 
   set(gca,'Ticklength',[0.02;0.05]);
   box on;

axes(handles.axes3),
   xlimit = get(gca,'xlim');
   ylimit = get(gca,'ylim');
   text((xlimit(2)+xlimit(1))./2,(ylimit(2)+ylimit(1))./2,...
       {'\fontsize{14}Equal Area Plot'},...
       'HorizontalAlignment','center','BackgroundColor','w');
   set(gca,'XMinorTick','on');
   set(gca,'YMinorTick','on');
   set(gca,'XTickLabel','');  
   set(gca,'YTickLabel',''); 
   set(gca,'Ticklength',[0.015;0.04]);
   box on;

% Prepare Open Recent Menu   
fullfnames = getMRU();
handles.ffnames = fullfnames;

hMruMenu = findall(gcf, 'tag', 'OpenRecent');
for fileIdx = 1:length(fullfnames) 
   [pathstr,fname,ext] = fileparts(char(fullfnames{fileIdx}));
%    handles.hMRUcld(fileIdx) = uimenu(hMruMenu,'Label',[fname ext],...
%        'Callback',{@pushbutton1_Callback, handles, fullfnames{fileIdx}});
    uimenu(hMruMenu,'Label',[fname ext],...
       'Callback',{@pushbutton1_Callback, handles, fullfnames{fileIdx}});
end

% Choose default command line output for prog16
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes prog16 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = prog16_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

function fnames = getMRU()

if ispc
    home = [getenv('HOMEDRIVE') getenv('HOMEPATH')];
    pmagplotdir = [home '\Library\Preferences\PmagPlot'];
    prog16preffile = [pmagplotdir '\prog16.prf'];
else
    home = getenv('HOME');
    pmagplotdir = [home '/Library/Preferences/PmagPlot'];
    prog16preffile = [pmagplotdir '/prog16.prf'];
end

fid = fopen(prog16preffile, 'r'); 
if (fid >= 0)
    prfline = textscan(fid,'%s');
    fclose(fid);
    cprfline = char(prfline{1}); 
    fnames = {};
    for ii = 1:size(cprfline,1)
        fnametop = strfind(cprfline(ii,:), 'DataMRU');
        if fnametop == 1;
           fnames = [fnames; cellstr(cprfline(ii,fnametop+10:end))];  
        end
    end
else
    fnames = [];
end  


function [hObject, eventdata, handles] = setMRU(hObject, eventdata, handles)

if ispc
    home = [getenv('HOMEDRIVE') getenv('HOMEPATH')];
    myprefdir = [home '\Library\Preferences'];
    pmagplotdir = [home '\Library\Preferences\PmagPlot'];
else
    home = getenv('HOME');
    myprefdir = [home '/Library/Preferences'];
    pmagplotdir = [home '/Library/Preferences/PmagPlot'];
end

if exist(pmagplotdir) == 0,
   mkdir(myprefdir,'PmagPlot');
end

if ispc
    prog16preffile = [pmagplotdir '\prog16.prf'];
else
    prog16preffile = [pmagplotdir '/prog16.prf'];    
end    

openfname = [handles.PathName handles.FileName];
fullfnames = getMRU();
handles.ffnames = fullfnames;
exiflag = 0;
for ii = 1:length(handles.ffnames)
    if strcmp(handles.ffnames{ii}, openfname),
       exiflag = 1;
       oldii = ii;
    end
end

if exiflag,
   handles.ffnames(oldii)=[];
end

fidd = fopen(openfname);
if (fidd >= 0)
  handles.ffnames = cellstr([openfname; handles.ffnames]);
  fclose(fidd);
end

maxorlist = 9;
fid = fopen(prog16preffile, 'w');
listleng = min(length(handles.ffnames), maxorlist);
for ii = 1:listleng
   fprintf(fid, '%7s%1d%2s%s\n',...
          'DataMRU',listleng-ii+1,'=S', handles.ffnames{ii});
end
fclose(fid);


% open recent list update
fullfnames = handles.ffnames;
hMruMenu2 = findall(gcf, 'tag', 'OpenRecent');
hAllMenuItems = allchild(hMruMenu2);
delete(hAllMenuItems);

for fileIdx = 1:length(fullfnames) 
   [pathstr,fname,ext] = fileparts(char(fullfnames{fileIdx}));
   uimenu(hMruMenu2,'Label',[fname ext],...
       'Callback',{@pushbutton1_Callback, handles, fullfnames{fileIdx}});
end

% guidata(hObject,handles);


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles, recentfile)

if nargin < 4 
    try, cd(handles.PathName), end
       [handles.FileName, handles.PathName] =...
           uigetfile({'*.txt',  'datafiles (*.txt)'; ...
             '*.*',  'All Files (*.*)'}, ... 
                'Pick a tspin data file (*.txt)');
        if (handles.FileName==0) return 
        end
else
    [pathstr,fname,ext] = fileparts(recentfile);
    if ispc
        handles.PathName = [pathstr '\'];
    else
        handles.PathName = [pathstr '/'];
    end    
    handles.FileName = [fname ext];
end

    jj = strfind(handles.FileName, '.');
    handles.fnamecore = handles.FileName(1:jj-1);

if ~isequal(handles.FileName,0), 
    tA(:,:) = zeros(0);     did = []; 
   fidd = fopen([handles.PathName handles.FileName]);
    if (fidd < 0)
      [hObject, eventdata, handles] = setMRU(hObject, eventdata, handles);
      msgbox(['''', handles.FileName, ''' is NOT found.'],...
                'datafile loading error','error');
%       fclose(fidd);
      return
    else
%      set(handles.figure1, 'Name', handles.FileName);   
      ii = 1;
%       tline = fgetl(fidd);   % first line ignored
      while ~feof(fidd)
        tline = fgetl(fidd);
        if ~(isempty(strtrim(tline)) || strncmp(strtrim(tline), '!', 1))
          did = [did; cellstr(strtrim(tline))];
          tline = fgetl(fidd);   
          while ~(isempty(strtrim(tline)) || strncmp(strtrim(tline), '!', 1))
            Aline = textscan(tline, '%f');
%             Aline = textscan(tline, '%f@%f@%f@%f@%f');
            indexAline = [ii; Aline{1}];
%             indexAline = [ii; Aline{1,1}];
            if (size(tA,1) ~= 0 && size(tA,1) ~= size(indexAline,1)) 
                 break; end
            tA = [tA, indexAline];
            if feof(fidd), break; end
            tline = fgetl(fidd);
          end
          ii = ii+1;
          if (size(tA,1) ~= 0 && size(tA,1) ~= size(indexAline,1)) 
%              msgbox(['''', handles.FileName, ''' is NOT loaded.'], 'datafile loading error','error') ;
             break; 
          end
        end
      end
      fclose(fidd);  
      A = tA';  
    end

    set(handles.CopyFigure,'Enable','on');
    set(handles.Save,'Enable','on');
    set(handles.Move,'Enable','on');
    set(handles.Regression,'Enable','on');

    if size(A,2) >= 5
        set(handles.figure1, 'Name', handles.FileName);   %window title

        handles.SpecimenName     = char(did);
        handles.SpecimenIndex    = A(:,1);
        handles.UniqueSpecimen = unique(handles.SpecimenIndex);
        handles.DemagSteps       = A(:,2);
        handles.decl             = A(:,3);
        handles.incl             = A(:,4);
        handles.Intensity        = A(:,5);
    %     handles.error            = A(:,6);

        handles.East             = handles.Intensity.*...
            cosd(handles.incl).*sind(handles.decl);
        handles.North            = handles.Intensity.*...
            cosd(handles.incl).*cosd(handles.decl);
        handles.Vertical         = handles.Intensity.*...
            sind(handles.incl);

    %     handles.grid  = 0; 
        handles.holdon = 0;
    %     handles.titleon = 0;
        handles.Dimension       = 2;
        handles.AutoRot         = 0;
        handles.WestUp          = 1;
        handles.AnchorOrigin    = 0;

        handles.NormInt = [];  NormInt = [];
        for ii = 1:handles.UniqueSpecimen(end)
           handles.CurrentIndexes   = find(handles.SpecimenIndex == handles.UniqueSpecimen(ii));
           handles.InitInt          = handles.Intensity(handles.CurrentIndexes(1));
           handles.NormInt          = [handles.NormInt; ...
                   handles.Intensity(handles.CurrentIndexes)/handles.InitInt];
        end

        handles.SpecimenIndexNow = 1;
    %     handles.IntPlotDemag     = ceil(length(handles.CurrentIndexes)./2);

    %     handles.IntPlot = handles.Intensity; 
    %    handles.HoldZplotAxesNorthUp = [min(handles.East) max(handles.East) min([handles.North; -handles.Vertical]) max([handles.North; -handles.Vertical])];
    %     handles.HoldZplotAxesWestUp  = [min(handles.North) max(handles.North) min([-handles.East; -handles.Vertical]) max([-handles.East; -handles.Vertical])];

        % jumpto list
        hMoveMenu = findall(gcf, 'tag', 'Move');
        hJutMenu = findall(gcf, 'tag', 'Jumpto');
        delete(hJutMenu);
        hJutMenu = uimenu('Label','Jump to', 'tag', 'Jumpto', 'Separator', 'on', 'Parent', hMoveMenu);

        for ii = 1:length(handles.UniqueSpecimen)
           uimenu(hJutMenu,'Label',num2str(handles.SpecimenName(ii, :)),...
               'tag', num2str(ii),...
               'Callback',{@pushbutton4_Callback, handles, ii});
        end

        handles.SpecimenIndexPre = handles.SpecimenIndexNow;
        [hObject, eventdata, handles] =...
            Update_SpecimenRelated(hObject, eventdata, handles);

        guidata(hObject,handles);

        [hObject, eventdata, handles] = setMRU(hObject, eventdata, handles);
        
    else
        msgbox(['''', handles.FileName, ''' is NOT loaded.'], 'datafile loading error','error') ;
    end    
else 
    msgbox('Operation cancelled by user, no data file loaded.', 'data file loading confirmation','warn') ;  

end


%% [Push] Top Specimen
function pushbutton7_Callback(hObject, eventdata, handles)

handles.SpecimenIndexPre = handles.SpecimenIndexNow;
handles.SpecimenIndexNow = 1;

[hObject, eventdata, handles] = Update_SpecimenRelated(hObject, eventdata, handles);

guidata(hObject,handles);

%% [Push] Next Specimen
function pushbutton2_Callback(hObject, eventdata, handles)

handles.SpecimenIndexPre = handles.SpecimenIndexNow;
handles.SpecimenIndexNow = handles.SpecimenIndexNow + 1;

if handles.SpecimenIndexNow <= length(handles.UniqueSpecimen),
   [hObject, eventdata, handles] = Update_SpecimenRelated(hObject, eventdata, handles);
else
   handles.SpecimenIndexNow = handles.SpecimenIndexNow - 1;
end

guidata(hObject,handles);

%% [Push] Previous Specimen
function pushbutton3_Callback(hObject, eventdata, handles)

handles.SpecimenIndexPre = handles.SpecimenIndexNow;
handles.SpecimenIndexNow = handles.SpecimenIndexNow - 1;

if handles.SpecimenIndexNow >= 1,
   [hObject, eventdata, handles] = Update_SpecimenRelated(hObject, eventdata, handles);
else
   handles.SpecimenIndexNow = handles.SpecimenIndexNow + 1;
end

guidata(hObject,handles);

%% [Push] Last Specimen
function pushbutton8_Callback(hObject, eventdata, handles)

handles.SpecimenIndexPre = handles.SpecimenIndexNow;
handles.SpecimenIndexNow = handles.UniqueSpecimen(end);

[hObject, eventdata, handles] = Update_SpecimenRelated(hObject, eventdata, handles);

guidata(hObject,handles);

%% [Push] Jump to Specimen
function pushbutton4_Callback(hObject, eventdata, handles, specnum)

handles.SpecimenIndexPre = handles.SpecimenIndexNow;
handles.SpecimenIndexNow = specnum;

[hObject, eventdata, handles] =...
    Update_SpecimenRelated(hObject, eventdata, handles);

guidata(hObject,handles);


%% [Function] Update_SpecimenRelated
function [hObject, eventdata, handles] = Update_SpecimenRelated(hObject, eventdata, handles)

handles.Regres = [];

handles.CurrentIndexes   = find(handles.SpecimenIndex == handles.SpecimenIndexNow); 

level = num2str(handles.DemagSteps(handles.CurrentIndexes));
set(handles.text2,'String',handles.SpecimenName(handles.SpecimenIndexNow,:));
set(handles.text5,'String',char(level));
% set(handles.text5,'FontSize',24.0);


handles.DemagStart4Plot  = handles.DemagSteps(handles.CurrentIndexes(1));
handles.DemagEnd4Plot    = handles.DemagSteps(handles.CurrentIndexes(end));
handles.pcaon = 0;
Update_zdplot(hObject, eventdata, handles);
Update_eaplot(hObject, eventdata, handles);
Update_IntDemagPlot(hObject, eventdata, handles);

set(handles.pcapanel,'Checked','off'); 
set(handles.uipanel2, 'Visible','off');
set(handles.text3, 'Visible','off');


%% [Function] Update_zdplot
function Update_zdplot(hObject, eventdata, handles)

% update_zdplot updates the zdplot base on the updated
% parameters that controls the zdplot.

axes(handles.axes1),
tickdiv =  pcazdplot(handles.East(handles.CurrentIndexes),...
          handles.North(handles.CurrentIndexes),...
          handles.Vertical(handles.CurrentIndexes),...
          handles.DemagSteps(handles.CurrentIndexes),...
          handles.DemagStart4Plot,handles.DemagEnd4Plot,...
          handles.WestUp,...
          handles.Regres, handles.pcaon);

formatspec = '%6.1e';
set(handles.divtext,'String',['Div. =  ' num2str(tickdiv, formatspec)]);

if handles.holdon == 1, hold on; end;


%% [function] Update_Equal Area Plot
function Update_eaplot(hObject, eventdata, handles)

axes(handles.axes3), 
pcaequalareaplot(handles.decl(handles.CurrentIndexes),...
                 handles.incl(handles.CurrentIndexes),...
                 handles.East(handles.CurrentIndexes),...
                 handles.North(handles.CurrentIndexes),...
                 handles.Vertical(handles.CurrentIndexes),...
                 handles.DemagSteps(handles.CurrentIndexes),...
                 handles.DemagStart4Plot,handles.DemagEnd4Plot,...
                 handles.Regres, handles.pcaon);    
                         
guidata(hObject,handles);


%% [Function] Update_IntDemagPlot
function Update_IntDemagPlot(hObject, eventdata, handles)

axes(handles.axes2),
intdemagplot(handles.NormInt(handles.CurrentIndexes),...
               handles.DemagSteps(handles.CurrentIndexes),...
                 handles.DemagStart4Plot, handles.DemagEnd4Plot);

formatspec = '%7.2e';
J0str = ['Jo = ', num2str(handles.Intensity(handles.CurrentIndexes(1)), formatspec)];
set(handles.text4,'String',J0str);

guidata(hObject,handles);



%% [uipanel] toggle Regression panel
function pushbutton11_Callback(hObject, eventdata, handles)

handles.DemagStart4Plot  = handles.DemagSteps(handles.CurrentIndexes(1));
handles.DemagEnd4Plot    = handles.DemagSteps(handles.CurrentIndexes(end));
handles.pcaon = 0;
Update_zdplot(hObject, eventdata, handles);
Update_eaplot(hObject, eventdata, handles);
Update_IntDemagPlot(hObject, eventdata, handles);
set(handles.text3, 'Visible','off');

if strcmp(get(handles.pcapanel,'Checked'),'on'), 
    set(handles.uipanel2, 'Visible','on');
    set(handles.checkbox1,'Value',0);
else
    set(handles.uipanel2, 'Visible','off');
end

fromstr = char('From', num2str(handles.DemagSteps(handles.CurrentIndexes)));    
tostr = char('To',   num2str(handles.DemagSteps(handles.CurrentIndexes)));    
set(handles.popupmenu3,'String',fromstr);
set(handles.popupmenu3,'Value',1);    
set(handles.popupmenu4,'String',tostr);
set(handles.popupmenu4,'Value',1);

guidata(hObject,handles);


%% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
    popupmenu4_Callback(hObject, eventdata, handles)


%% --- Executes on selection change in popupmenu4.
function popupmenu4_Callback(hObject, eventdata, handles)

if (get(handles.popupmenu3,'Value') > 1) && (get(handles.popupmenu4,'Value') > 1)
handles.DemagStart4PCA = handles.DemagSteps(handles.CurrentIndexes(...
                                   get(handles.popupmenu3,'Value')-1));
handles.DemagEnd4PCA   = handles.DemagSteps(handles.CurrentIndexes(...
                                   get(handles.popupmenu4,'Value')-1));

    if handles.DemagStart4PCA < handles.DemagEnd4PCA
        handles.pcaon = 0;
        axes(handles.axes1),
        tickdiv = pcazdplot(handles.East(handles.CurrentIndexes),...
                          handles.North(handles.CurrentIndexes),...
                          handles.Vertical(handles.CurrentIndexes),...
                          handles.DemagSteps(handles.CurrentIndexes),...
                          handles.DemagStart4PCA, handles.DemagEnd4PCA,...
                          handles.WestUp,...
                          handles.Regres, handles.pcaon);

        formatspec = '%6.1e';
        set(handles.divtext,'String',['Div. =  ' num2str(tickdiv, formatspec)]);
        
        if handles.holdon == 1, hold on; end;

        axes(handles.axes3), 
        pcaequalareaplot(handles.decl(handles.CurrentIndexes),...
                         handles.incl(handles.CurrentIndexes),...
                         handles.East(handles.CurrentIndexes),...
                         handles.North(handles.CurrentIndexes),...
                         handles.Vertical(handles.CurrentIndexes),...
                         handles.DemagSteps(handles.CurrentIndexes),...
                         handles.DemagStart4PCA, handles.DemagEnd4PCA,...
                         handles.Regres, handles.pcaon);    

        axes(handles.axes2),
        intdemagplot(handles.NormInt(handles.CurrentIndexes),...
                       handles.DemagSteps(handles.CurrentIndexes),...
                         handles.DemagStart4PCA,handles.DemagEnd4PCA);

        guidata(hObject,handles);
    end
end    


%% [Push] Update PCArelated
function pushbutton9_Callback(hObject, eventdata, handles)

if (get(handles.popupmenu3,'Value') > 1) && (get(handles.popupmenu4,'Value') > 1)
handles.DemagStart4PCA = handles.DemagSteps(handles.CurrentIndexes(...
                                   get(handles.popupmenu3,'Value')-1));
handles.DemagEnd4PCA   = handles.DemagSteps(handles.CurrentIndexes(...
                                   get(handles.popupmenu4,'Value')-1));

    if handles.DemagStart4PCA < handles.DemagEnd4PCA
        [hObject, eventdata, handles] = Update_PCA(hObject, eventdata, handles);
        Update_PCAboxes(hObject, eventdata, handles);
        handles.pcaon = 1;

        axes(handles.axes1),
        tickdiv = pcazdplot(handles.East(handles.CurrentIndexes),...
                          handles.North(handles.CurrentIndexes),...
                          handles.Vertical(handles.CurrentIndexes),...
                          handles.DemagSteps(handles.CurrentIndexes),...
                          handles.DemagStart4PCA, handles.DemagEnd4PCA,...
                          handles.WestUp,...
                          handles.Regres, handles.pcaon);

        formatspec = '%6.1e';
        set(handles.divtext,'String',['Div. =  ' num2str(tickdiv, formatspec)]);

        if handles.holdon == 1, hold on; end;

        axes(handles.axes3), 
        pcaequalareaplot(handles.decl(handles.CurrentIndexes),...
                         handles.incl(handles.CurrentIndexes),...
                         handles.East(handles.CurrentIndexes),...
                         handles.North(handles.CurrentIndexes),...
                         handles.Vertical(handles.CurrentIndexes),...
                         handles.DemagSteps(handles.CurrentIndexes),...
                         handles.DemagStart4PCA, handles.DemagEnd4PCA,...
                         handles.Regres, handles.pcaon);    

    guidata(hObject,handles);
    end
        
end


%% [Function] Update_PCA
function [hObject, eventdata, handles] = Update_PCA(hObject, eventdata, handles)
                               
if get(handles.checkbox1,'Value') == get(handles.checkbox1,'Max'), 
    handles.AnchorOrigin = 1; 
else handles.AnchorOrigin = 0; 
end

[handles.Regres(1), handles.Regres(2), handles.Regres(3)] =...
          pmgpca( handles.East(handles.CurrentIndexes),...
                  handles.North(handles.CurrentIndexes),...
                  handles.Vertical(handles.CurrentIndexes),...
                  handles.DemagSteps(handles.CurrentIndexes),...
                  handles.DemagStart4PCA, handles.DemagEnd4PCA,...
                  handles.AnchorOrigin);
              

              
%% [Function] Update_PCAboxes
function Update_PCAboxes(hObject, eventdata, handles)

set(handles.uipanel2,'Visible','off');
set(handles.pcapanel,'Checked','off'); 

set(handles.text3, 'Visible','on');

rangefrom = ['Fit from ', num2str(handles.DemagStart4PCA)];
rangeto   = ['     to ', num2str(handles.DemagEnd4PCA)];
formatspec = '%6.1f';
fitdec    = ['Dec   = ', num2str(handles.Regres(1),formatspec)];
fitinc    = ['Inc    = ', num2str(handles.Regres(2),formatspec)];
fitmad    = ['MAD = ', num2str(handles.Regres(3),formatspec)];

if get(handles.checkbox1,'Value') == get(handles.checkbox1,'Max'), 
   anchored = ['  [anchored]']; 
   set(handles.text3,'String',...
         char(rangefrom, rangeto, anchored, fitdec, fitinc, fitmad));
else
   set(handles.text3,'String',...
         char(rangefrom, rangeto, fitdec, fitinc, fitmad));    
end


%% [Push] Regression export
function pushbutton12_Callback(hObject, eventdata, handles)

if ~isempty(handles.Regres)

    dummya95 = 1;
    pcaout = [handles.Regres, handles.AnchorOrigin];

    % spaces are deleted
    remain = strtrim(handles.SpecimenName(handles.SpecimenIndexNow,:));
    specname = [];
    while true
       [str, remain] = strtok(remain);
       specname = [specname, str];
       if isempty(str),  break;  end
    end

%     filePathName = [handles.PathName, specname, 'pca.txt'];
    filePathName = [handles.PathName, handles.fnamecore, 'pca.txt'];

    range = [num2str(handles.DemagStart4PCA) '-' num2str(handles.DemagEnd4PCA)];
    if length(specname) > 20, 
        specname = specname(1:20);
    end

    if fopen(filePathName)==-1,
       fid = fopen(filePathName,'at');
       fprintf(fid,...
         '!specimen               Dec     Inc     MAD   Anchor  Range\n');
       fprintf(fid, '%-20s\n', handles.fnamecore);
       fclose(fid);
       msgbox(['''', handles.fnamecore, 'pca.txt''',...
           ' has been created for saving PCA data ''',...
           handles.SpecimenName(handles.SpecimenIndexNow,:),''''],...
               'PCA data export confirmation','help');
    end

    fid = fopen(filePathName, 'at'); % 'a' here means append, 't' means text mode
    fprintf(fid, '%-20s  %6.1f  %6.1f %6.1f  %5d    %-10s\n',...
              specname, pcaout', range);
    fclose(fid);

    set(handles.edit7, 'Visible','on');
    set(handles.edit7,'String',['PCA data added for ',...
         handles.SpecimenName(handles.SpecimenIndexNow,:)]);
    pause(2);
    set(handles.edit7, 'Visible','off');
end

 
%% [Push] Save Figure(s)
function pushbutton6_Callback(hObject, eventdata, handles)

H = prog16_SavePlotOption_dlg;
uiwait(H);

savePlotOption = getappdata(0, 'savePlotOptionUDIR');
rmappdata(0, 'savePlotOptionUDIR');

% spaces are deleted
remain = strtrim(handles.SpecimenName(handles.SpecimenIndexNow,:));
specname = [];
while true
   [str, remain] = strtok(remain);
   specname = [specname, str];
   if isempty(str),  break;  end
end

switch savePlotOption
    case 1
         plotstring = [specname,'ze'];
         h  = handles.figure1;
         xlimit = get(handles.figure1,'xlim');
         ylimit = get(handles.figure1,'ylim');        
    case 2    
         plotstring = [specname,'zv'];
         h  = findobj(handles.axes1,'type','axes');
         xlimit = get(handles.axes1,'xlim');
         ylimit = get(handles.axes1,'ylim');        
    case 3    
         plotstring = [specname,'ea'];
         h  = findobj(handles.axes3,'type','axes');   
         xlimit = get(handles.axes3,'xlim');
         ylimit = get(handles.axes3,'ylim');         
    case 4    
         plotstring = [specname,'li'];
         h  = findobj(handles.axes2,'type','axes');   
         xlimit = get(handles.axes2,'xlim');
         ylimit = get(handles.axes2,'ylim');
         
    otherwise    % cancelled, no data for saving
         return;     
end

[filename, pathname, FilterIndex] =...
uiputfile({'*.pdf','Portable Document Format (*.pdf)';
            '*.eps','EPS Level2 (*.eps)';
            '*.png','Portable Network Graphics (*.png)';
            '*.jpg','JPEG image (*.jpg)';
            '*.tif','TIFF image (*.tif)';
            '*.bmp','Windows bitmap (*.bmp)';
            '*.fig','MATLAB figure (*.fig)'},...
            'Save selected plot as',...
            [handles.PathName, plotstring]);

if  ~isequal(filename,0), 
    if savePlotOption ==1
        orient landscape
        newFig = handles.figure1;
        if FilterIndex == 2,
           saveas(newFig,[pathname,filename], 'psc2');
        else   
           saveas(newFig,[pathname,filename]);
        end
    else
        newFig = figure('Units', 'default', 'Position', 'default');
        newAxes = copyobj(h,newFig); 
        set(newAxes,'Units','default','Position','default');
        set(newAxes, 'xlim', xlimit);
        set(newAxes, 'ylim', ylimit);
        if FilterIndex == 2,
           saveas(newFig,[pathname,filename], 'psc2');
        else   
           saveas(newFig,[pathname,filename]);
        end
        close(newFig);
    end    

end



%% [Function] zdplot
function [div] = pcazdplot(east, north, vertical, demagsteps,...
                    demagstart, demagend, westup, pcares, pcaon)

% zdplot generates zijderveld plot for the given data within the specified
% demagnetization range;

% define demag range and scaling factor
demagrange = find(demagsteps >= demagstart & demagsteps <= demagend);

if length(demagrange) >  4, demaglabel = 1;
else demaglabel = 0;
end

northg = sum(north(demagrange))/length(north(demagrange));
neastg = sum(-east(demagrange))/length(east(demagrange));
nvertg = sum(-vertical(demagrange))/length(vertical(demagrange));

% if ispc   
%    zjfs = 10;    zjms = 5;
% else
%    zjfs = 11;    zjms = 6;   
% end
   zjfs = 11;    zjms = 6;   

if westup ==1, % West/Up Axes

    verticalscaling = 0.08*(max([-east;-vertical])-min([-east;-vertical])); % tick related
    horizontalscaling = 0.14*(max(north)-min(north)); % tick related
    
    xxlim = [min([min(north)-horizontalscaling;-horizontalscaling]),...
                max([max(north)+horizontalscaling;horizontalscaling])];
    yylim = [min([min([-east;-vertical;])-verticalscaling;-verticalscaling]),...
           max([max([-east;-vertical])+verticalscaling; verticalscaling])];            
   
    % Horizontal Projection
    plot(north, -east, '-','LineWidth',1, 'color', [0.7 0.7 0.7]); hold on;
    plot(north, -east, 'o','color', [0.7 0.7 0.7],'MarkerFaceColor',[0.8 0.8 0.8],'MarkerSize',zjms); hold on;
    plot(north(demagrange), -east(demagrange), 'b-','LineWidth',1); hold on;
    plot(north(demagrange), -east(demagrange), 'bo','MarkerFaceColor','b','MarkerSize',zjms); hold on;
    % Vertical Projection
    plot(north, -vertical, '-','LineWidth',1, 'LineStyle','--','color', [0.7 0.7 0.7]); hold on;
    plot(north, -vertical, 'o','color', [0.7 0.7 0.7],'MarkerFaceColor','none','MarkerSize',zjms); hold on;
    plot(north(demagrange),-vertical(demagrange),'r-','LineWidth',1,'LineStyle','--'); hold on;
    plot(north(demagrange),-vertical(demagrange),'ro','MarkerFaceColor','none','MarkerSize',zjms); hold on;

    % add x-axis  
    line([xxlim(1) xxlim(2)], [0 0],'LineWidth',0.5,'color',[0 0 0]);hold on
    text(max([max(north)+horizontalscaling;horizontalscaling]),0,'N','fontsize',zjfs,'color',[0 0 0]); 
    text(min([min(north)-horizontalscaling;-horizontalscaling]),0,'S','HorizontalAlignment','right','fontsize',zjfs,'color',[0 0 0]); 
    % add y-axis
    line([0 0], [yylim(1) yylim(2)],'LineWidth',0.5,'color',[0 0 0]); hold on;
    text(0,max([max([-east;-vertical])+verticalscaling; verticalscaling]),'W Up','HorizontalAlignment','center','VerticalAlignment','Bottom','fontsize',zjfs,'color',[0 0 0]); 
    text(0,min([min([-east;-vertical;])-verticalscaling;-verticalscaling]),'E Down','HorizontalAlignment','center','VerticalAlignment','Top','fontsize',zjfs,'color',[0 0 0]); 

    % Regression lines
    if pcaon
        pcaeast  = cosd(pcares(2))*sind(pcares(1));
        pcanorth = cosd(pcares(2))*cosd(pcares(1));
        pcavert  = sind(pcares(2));
            
        xpoint = linspace(xxlim(1),xxlim(2),100);
        yh = -pcaeast/pcanorth*(xpoint-northg)+neastg;
        yv = -pcavert/pcanorth*(xpoint-northg)+nvertg;
        plot(xpoint,yh,'g-', xpoint,yv,'g--');   
        hold on;
    end    
        axis equal;
        axis([xxlim(1) xxlim(2) yylim(1) yylim(2)]);
        hold on;   
    
else % North/Up Axes (temporarily not available)

    verticalscaling = 0.08*(max([north(demagrange);-vertical(demagrange)])-min([north(demagrange);-vertical(demagrange)])); % tick related
    horizontalscaling = 0.14*(max(east(demagrange))-min(east(demagrange))); % tick related
    % Horizontal Projection
    plot([east(demagrange);0], [north(demagrange);0], 'b-','LineWidth',1); hold on;
    plot(east(demagrange), north(demagrange), 'bo','MarkerFaceColor','b','MarkerSize',zjms); hold on;
    % Vertical Projection
    plot([east(demagrange);0],[-vertical(demagrange);0],'r-','LineWidth',1); hold on;
    plot(east(demagrange),-vertical(demagrange),'rs','MarkerFaceColor','none','MarkerSize',zjms); hold on;
    % label 2 demag steps
    text(east(demagrange(1+demaglabel)), -vertical(demagrange(1+demaglabel)),['  ',num2str(demagsteps(demagrange(1+demaglabel)))],'HorizontalAlignment','left','VerticalAlignment','Middle','FontSize',9);
    text(east(demagrange(end-demaglabel)), -vertical(demagrange(end-demaglabel)),['  ',num2str(demagsteps(demagrange(end-demaglabel)))],'HorizontalAlignment','left','VerticalAlignment','Middle','FontSize',9);    
    % add x axis
    line([min([min(east(demagrange))-horizontalscaling;-horizontalscaling]) max([max(east(demagrange))+horizontalscaling;horizontalscaling])], [0 0],'LineWidth',0.5,'color',[0 0.5 0]);hold on
    text(max([max(east(demagrange))+horizontalscaling;horizontalscaling]),0,'   E','fontsize',zjfs,'color',[0 0.5 0]); 
    text(min([min(east(demagrange))-horizontalscaling;-horizontalscaling]),0,'W   ','HorizontalAlignment','right','fontsize',zjfs,'color',[0 0.5 0]); 
    plot([min([min(east(demagrange))-horizontalscaling;-horizontalscaling]) min([min(east(demagrange))-horizontalscaling;-horizontalscaling])],...
         [-0.35*verticalscaling 0.35*verticalscaling],'-','color',[0 0.5 0]);
    plot([max([max(east(demagrange))+horizontalscaling;horizontalscaling]) max([max(east(demagrange))+horizontalscaling;horizontalscaling])],...
         [-0.35*verticalscaling 0.35*verticalscaling],'-','color',[0 0.5 0]);
    % add y-axis
    line([0 0], [min([min([north(demagrange);-vertical(demagrange);])-verticalscaling;-verticalscaling]) max([max([north(demagrange);-vertical(demagrange)])+verticalscaling; verticalscaling])],'LineWidth',0.5,'color',[0 0.5 0]); hold on;
    text(0,max([max([north(demagrange);-vertical(demagrange)])+verticalscaling; verticalscaling]),'N,Up','HorizontalAlignment','center','VerticalAlignment','Bottom','fontsize',9,'color',[0 0.5 0]); 
    text(0,min([min([north(demagrange);-vertical(demagrange);])-verticalscaling;-verticalscaling]),'S,Down','HorizontalAlignment','center','VerticalAlignment','Top','fontsize',9,'color',[0 0.5 0]); 
    plot([-0.35*verticalscaling 0.35*verticalscaling],...
        [min([min([north(demagrange);-vertical(demagrange);])-verticalscaling;-verticalscaling]) min([min([north(demagrange);-vertical(demagrange);])-verticalscaling;-verticalscaling])],'-','color',[0 0.5 0]);
    plot([-0.35*verticalscaling 0.35*verticalscaling],...
        [max([max([north(demagrange);-vertical(demagrange)])+verticalscaling; verticalscaling]) max([max([north(demagrange);-vertical(demagrange)])+verticalscaling; verticalscaling])],'-','color',[0 0.5 0]);
end

% GET TICKS
X=get(gca,'Xtick');
Y=get(gca,'Ytick');
xtickspace = X(2)-X(1);
ytickspace = Y(2)-Y(1);
xrange = find(X >= xxlim(1) & X <= xxlim(2));
X=X(xrange);
yrange = find(Y >= yylim(1) & Y <= yylim(2));
Y=Y(yrange);
if xtickspace < ytickspace,
  ii = 1;  X = X(1);
  while X(ii) + ytickspace < xxlim(2)
    X = [X, X(ii) + ytickspace];
    ii = ii+1;
  end
elseif xtickspace > ytickspace,
  ii = 1;  Y = Y(1);
  while Y(ii) + xtickspace < yylim(2)
    Y = [Y, Y(ii) + xtickspace];
    ii = ii+1;
  end
end
div = max([xtickspace, ytickspace]);

% Plot new ticks  
for i=1:length(X)
    plot([X(i) X(i)],[-0.1*verticalscaling 0.1*verticalscaling],'-','color',[0 0 0]);
end;
for i=1:length(Y)
   plot([0.1*verticalscaling, -0.1*verticalscaling],[Y(i) Y(i)],'-','color',[0 0 0]);
end;

axis off;
hold off;


%% [Function] Equal Area Plot
function pcaequalareaplot(decl, incl, east, north, vertical, demagsteps,...
                             demagstart, demagend, pcares, pcaon)

demagrange = find(demagsteps >= demagstart & demagsteps <= demagend);

t=linspace(0,2*pi,10000);
xx = 90*cos(t);
yy = 90*sin(t);

% ---------add white background

area(xx, yy, 'facecolor', 'none', 'edgecolor', 'none',...
    'ShowBaseLine', 'off'); hold on;
   
% ---------draw a circle
plot(xx,yy,'k','LineWidth',2);
axis equal;
axis off;


% ---------Add incl ticks
inclstick = (10:10:80)';
plot(              0,               0,'k+','markersize',42,'MarkerFaceColor','k');

% ---------Add Decl tick
xdata = [90*sind(  0), 84*sind(  0), NaN, ...
         90*sind( 90), 84*sind( 90), NaN, ...
         90*sind(180), 84*sind(180), NaN, ...
         90*sind(270), 84*sind(270), NaN];   
ydata = [90*cosd(  0), 84*cosd(  0), NaN, ...
         90*cosd( 90), 84*cosd( 90), NaN, ...
         90*cosd(180), 84*cosd(180), NaN, ...
         90*cosd(270), 84*cosd(270), NaN];         
line('xdata', xdata, 'ydata', ydata);

% ----------Add label
text(0  ,  93, 'N'  , 'verticalalignment', 'bottom', 'horizontalalignment', 'center');

% ----------Add data
% if ispc   
%    snms = 5;
% else
%    snms = 6;   
% end
   snms = 6;   

% plotting points
indexp = find(incl>=0);
indexn = find(incl<0);
declp = decl(indexp);
decln = decl(indexn);
inclp = incl(indexp);
incln = incl(indexn);

xcp = (90-inclp).*sind(declp);
ycp = (90-inclp).*cosd(declp);
xcn = -(90+incln).*sind(180+decln);
ycn = -(90+incln).*cosd(180+decln);
plot(xcp, ycp, 'o', 'MarkerFaceColor',[0.7 0.7 0.7],'markersize',snms,...
      'color',[0.7 0.7 0.7]);
plot(xcn, ycn, 'o', 'color',[0.7 0.7 0.7],'MarkerFaceColor','none',...
      'markersize',snms);

% plotting regression points
indexp = intersect(indexp, demagrange);
indexn = intersect(indexn, demagrange);
declp = decl(indexp);
decln = decl(indexn);
inclp = incl(indexp);
incln = incl(indexn);

xcp = (90-inclp).*sind(declp);
ycp = (90-inclp).*cosd(declp);
xcn = -(90+incln).*sind(180+decln);
ycn = -(90+incln).*cosd(180+decln);
plot(xcp, ycp, 'bo', 'MarkerFaceColor','b','markersize',snms);
plot(xcn, ycn, 'ro', 'MarkerFaceColor','none','markersize',snms);

%drawing great-circle segments
mvec = [north, east, vertical];

angstep = 1.0/180.0*pi;
for ii=1:length(decl)-1
  angdis = acos(dot(mvec(ii,:), mvec(ii+1,:))/(norm(mvec(ii,:))*norm(mvec(ii+1,:))));
  g = cross(mvec(ii,:), mvec(ii+1,:));
  g = g/norm(g);
  l = g(1); m = g(2); n = g(3);
  
  rang = angstep; gcp = [];
  while rang < angdis 
    rmat = [l^2 + (1.0 - l^2)*cos(rang)  ...
               l*m*(1.0 - cos(rang)) - n*sin(rang)  ...
                  l*n*(1.0 - cos(rang)) + m*sin(rang);...
            l*m*(1.0-cos(rang)) + n*sin(rang)  ...
               m^2 + (1 - m^2)*cos(rang)  ...
                  m*n*(1.0-cos(rang))-l*sin(rang);...
            l*n*(1.0 - cos(rang)) - m*sin(rang)  ...
               m*n*(1.0 - cos(rang)) + l*sin(rang)  ...
                  n^2 + (1.0 - n^2)*cos(rang)];
    gcp = [gcp, rmat*mvec(ii,:)'];              
    rang = rang + angstep;
  end
  
  gcp = [mvec(ii,:)', gcp, mvec(ii+1,:)'];
  
  [dim, pnum] = size(gcp);  int = [];
  for jj = 1:pnum
    int = [int, norm(gcp(:,jj))];
  end
  dec = atan2d(gcp(2,:), gcp(1,:));
  if (dec <= 0) dec = dec + 360.0;  end  
  inc = asind(gcp(3,:)./int);

  indexlp = find(inc>=0);
  indexln = find(inc<0);
  incp = inc(indexlp); decp = dec(indexlp);
  incn = inc(indexln); decn = dec(indexln);
  xlp =  (90-incp).*sind(decp);
  ylp =  (90-incp).*cosd(decp);
  xln = -(90+incn).*sind(180+decn);
  yln = -(90+incn).*cosd(180+decn);
  if ismember(ii, demagrange(1:end-1)) 
      plot(xlp, ylp, '-', 'color','b'); 
      plot(xln, yln, '--', 'color','r');  
  else
      plot(xlp, ylp, '-','color',[0.7 0.7 0.7]); 
      plot(xln, yln, '--','color',[0.7 0.7 0.7]);  
  end      
end

% Regression direction
if pcaon 
    if pcares(2)>=0
        xcp = (90-pcares(2)).*sind(pcares(1));
        ycp = (90-pcares(2)).*cosd(pcares(1));
        plot(xcp, ycp, 'go', 'MarkerFaceColor','g','markersize',snms);
    else
        xcn = -(90+pcares(2)).*sind(180+pcares(1));
        ycn = -(90+pcares(2)).*cosd(180+pcares(1));
        plot(xcn, ycn, 'go', 'MarkerFaceColor','none','markersize',snms);
    end
end
hold off;


%% [Function] int-demag plot
function intdemagplot(normint, demagsteps, demagstart, demagend)
 
demagrange = find(demagsteps >= demagstart & demagsteps <= demagend);

% if ispc   
%    idms = 4;
% else
%    idms = 5;   
% end
   idms = 5;   

plot(demagsteps,normint,...
     'o-',...
     'MarkerFaceColor','w',...
     'MarkerSize',idms, 'color',[0.7 0.7 0.7]); hold on;
plot(demagsteps,normint,...
     'o',...
     'color',[0.7 0.7 0.7],...
     'MarkerFaceColor',[0.7 0.7 0.7],...
     'MarkerSize',idms);
plot(demagsteps(demagrange),normint(demagrange),...
     'bo-',...
     'MarkerFaceColor','w',...
     'MarkerSize',idms); hold on;
plot(demagsteps(demagrange),normint(demagrange),...
     'bo',...
     'MarkerFaceColor','b',...
     'MarkerSize',idms); 
 
axis([0, inf, 0, inf]); 
set(gca,'XMinorTick','on');
set(gca,'YMinorTick','on');
set(gca,'Ticklength',[0.02;0.05]);
set(gca,'Color','none');
set(gca,'Box','off'); 

hold off;


%% [Function] pmagpca
function [decl, incl, mad] = pmgpca(east, north, vertical, demagsteps, demagstar, demagend, origindectector)
    
    data = [east,north,vertical];
    pcadata = data(find(demagsteps>=demagstar & demagsteps<=demagend),:);
    
    if  origindectector == 1,
 %       pcadata = [[0, 0, 0];pcadata];
 %       covdata = cov(pcadata);       % calculate covariance matrix of east-north-vetical varibles at certain position
        cvcm = [pcadata(:,1).*pcadata(:,2), pcadata(:,1).*pcadata(:,3),...
              pcadata(:,2).*pcadata(:,3)];
        cvc = sum(cvcm);
        utcd = [0 cvc(1) cvc(2); 0 0 cvc(3); 0 0 0];
        covdata = diag(sum(pcadata.^2)) + utcd + utcd';
        
        [xx,yy,zz] = pcacov(covdata); % calculate eigen values, eigen vectors (sorted) and corresponding var% for the cov matrix
        pcadirection = xx(:,1)*xx(:,1)'*pcadata';      % calculate coordinates of projection of points on pca line; positive constant 1./sum(xx(:,1).^2) is neglected.
        if sign(pcadirection(3,2)-pcadirection(3,end))~=sign(xx(3,1)),  % NEED TO BE CHECKED
        xx=-xx;                                     % check whether pca got the right direction by comparing sign of pca vertical coordinate (eigen vector associated with 
        end                                            % biggest eigen value) with vertical projection cordinates of demag200 and demag800 on pca line;                      
        mad = atand(sqrt((yy(2)+yy(3))/yy(1))); % 2nd column of pca(output data) is mad value
        decl = atand(abs(xx(1,1)/xx(2,1)));      % 4th column of pca(output data) is pca declination
        if xx(1,1)>0 && xx(2,1)<0, 
        decl = 180 - decl;
        end
        if xx(1,1)<0 && xx(2,1)>0, 
        decl = 360 - decl;
        end
        if xx(1,1)<0 && xx(2,1)<0,
        decl = 180 + decl;
        end  
        incl = asind(xx(3,1)/sqrt(sum(xx(:,1).^2))); % 5th column of pca(output data) is pca inclination
        
    else
        
        covdata = cov(pcadata);       % calculate covariance matrix of east-north-vetical varibles at certain position
        [xx,yy,zz] = pcacov(covdata); % calculate eigen values, eigen vectors (sorted) and corresponding var% for the cov matrix
        pcadirection = xx(:,1)*xx(:,1)'*pcadata';      % calculate coordinates of projection of points on pca line; positive constant 1./sum(xx(:,1).^2) is neglected.
        if sign(pcadirection(3,1)-pcadirection(3,end))~=sign(xx(3,1)), 
        xx=-xx;                                     % check whether pca got the right direction by comparing sign of pca vertical coordinate (eigen vector associated with 
        end                                            % biggest eigen value) with vertical projection cordinates of demag200 and demag800 on pca line;                      
        mad = atand(sqrt((yy(2)+yy(3))/yy(1))); % 2nd column of pca(output data) is mad value
        decl = atand(abs(xx(1,1)/xx(2,1)));      % 4th column of pca(output data) is pca declination
        if xx(1,1)>0 && xx(2,1)<0, 
        decl = 180 - decl;
        end
        if xx(1,1)<0 && xx(2,1)>0, 
        decl = 360 - decl;
        end
        if xx(1,1)<0 && xx(2,1)<0,
        decl = 180 + decl;
        end  
        incl = asind(xx(3,1)/sqrt(sum(xx(:,1).^2))); % 5th column of pca(output data) is pca inclination


    end
    
    
    
%% [popupmenu]
% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function popupmenu4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% [edit]
function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to text4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of text4 as text
%        str2double(get(hObject,'String')) returns contents of text4 as a double

% --- Executes during object creation, after setting all properties.
function text4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: move controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end

% --- Executes during object creation, after setting all properties.
function text5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: move controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end

% --- Executes during object creation, after setting all properties.
function divtext_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: move controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end

function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: move controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double

% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% [checkbox]
% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1


%% [Menu]
% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Open_Callback(hObject, eventdata, handles)
   pushbutton1_Callback(hObject, eventdata, handles);
% hObject    handle to Open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function OpenRecent_Callback(hObject, callbackdata, handles)
 % hObject    handle to OpenRecent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function Close_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --------------------------------------------------------------------
function CopyFigure_Callback(hObject, eventdata, handles)
    orient landscape
    if ispc
       print(handles.figure1,'-clipboard','-dmeta');     %for win
    else
       print(handles.figure1,'-clipboard','-dpdf');     %for mac
    end
    set(handles.edit7, 'Visible','on');
    set(handles.edit7,'String',['Copy to Clipboard: ',...
         handles.SpecimenName(handles.SpecimenIndexNow,:)]);
    pause(2);
    set(handles.edit7, 'Visible','off');

% hObject    handle to CopyFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Save_Callback(hObject, eventdata, handles)
   pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to Save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Move_Callback(hObject, eventdata, handles)
% hObject    handle to Move (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Top_Callback(hObject, eventdata, handles)
   pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to Top (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Forward_Callback(hObject, eventdata, handles)
   pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to Forward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Backward_Callback(hObject, eventdata, handles)
   pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to Backward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Last_Callback(hObject, eventdata, handles)
   pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to Last (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Jumpto_Callback(hObject, eventdata, handles)   
% hObject    handle to Jumptom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Regression_Callback(hObject, eventdata, handles)
% hObject    handle to Regression (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function pcapanel_Callback(hObject, eventdata, handles)
    if strcmp(get(handles.pcapanel,'Checked'),'on'), 
         set(handles.pcapanel,'Checked','off'); 
    else
         set(handles.pcapanel,'Checked','on');
    end
    
    pushbutton11_Callback(hObject, eventdata, handles);
% hObject    handle to pcapanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function ExportPCA_Callback(hObject, eventdata, handles)
   pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to ExportPCA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Exportpdf_Callback(hObject, eventdata, handles)

    % spaces are deleted
    remain = strtrim(handles.SpecimenName(handles.SpecimenIndexNow,:));
    specname = [];
    while true
       [str, remain] = strtok(remain);
       specname = [specname, str];
       if isempty(str),  break;  end
    end

    plotstring = [specname,'ze'];
    h  = handles.figure1;
    xlimit = get(handles.figure1,'xlim');
    ylimit = get(handles.figure1,'ylim');

    [filename, pathname, FilterIndex] =...
    uiputfile([handles.PathName, plotstring, '.pdf']);

    if  ~isequal(filename,0),
        orient landscape
        newFig = handles.figure1;
        saveas(newFig,[pathname,filename]);
    end
         
